<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Services;

use App\Http\Models\AdministratorgroupaccessModel;
use App\Http\Models\RolesModel;
use App\Http\Models\RolelokasiitemModel;
use App\Http\Models\RolecategoryModel;
use App\Http\Base\BaseService;
use Illuminate\Support\Facades\DB;

class RolesService extends BaseService
{
    /**
     * RolesService constructor.
     */
    public function __construct()
    {
        parent::__construct();
        $this->model = new RolesModel();
    }

    /**
     *  index function that get all data from database by default
     * @return array|static[]
     */
    public function index()
    {
        return $this->model->getQuery()->get();
    }

    public function groupHasSubinv($roleId)
    {
        return (new RolelokasiitemModel)->getQuery()->where("roleId", "=", $roleId)->get();
    }

    public function groupHasCategories($roleId)
    {
        return (new RolecategoryModel)->getQuery()->where("roleId", "=", $roleId)->get();
    }


    /**
     *  this function is magic pagination injector from my library you want to add new property or field you have to inject into model in alias paging property
     * @param array $input
     * @return array
     */
    public function paging($request)
    {
        $auth = json_decode($request->session()->get('auth'));
        
        $this->model->getQuery()->select([
            "roles.*"
        ]);
        
        $this->model->paging()->filter()->sorting();
        return $this->model->paging()->getPaging();
    }

    /**
     *  get one raw row data from table by id
     *  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
     *  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
     *  and you want to take value like this $model->fieldname
     * @param $id
     * @return RolesModel
     */
    public function show($id, $operator = "=", $field = "id")
    {
        $model = $this->model->getQuery()->where("roles." . $field, $operator, $id)->first();
        return $model;
    }


    /**
     *  this is a base function for storing data you with transaction by default
     *  you can customization base on your business requirement as you want, you can add other object or you can to loop anc excecute the process in single process
     * @param array $input
     * @return RolesModel
     * @throws \Exception
     */
    public function store($input)
    {        
        $transaction = new RolesModel();
		$transaction->fill($input);			
		if(! $transaction->save()){
			throw new \Exception();
		}
		return $transaction->id;
    }


    /**
     * this function will delete much data, in one action
     * the ids is a parameter from view like 1,2,3,4 and the parameter will be exploded into single array
     * you can remove this main alogorithm with your business requirement like soft delete or anything you want
     * @param $ids
     */
    public function delete($ids)
    {
        $params = explode(",", $ids);
        $this->model->destroyBulk("id", $params);

        (new AdministratorgroupaccessModel())->deleteData()->whereIn("administratorgroupaccess.groupid", $params)->delete();
        (new RolelokasiitemModel())->deleteData()->whereIn("rolelokasiitem.roleId", $params)->delete();
        (new RolecategoryModel())->deleteData()->whereIn("rolecategory.roleId", $params)->delete();
    }


    /**
     *  this is a base function for update and delete data by default.
     *  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or
     *  you can add multiple relation proses after update in this function
     * @param $id
     * @param array $input
     * @return RolesModel
     * @throws \Exception
     */
    public function update($id, $input)
    {
        $roles = RolesModel::find($id);
        $roles->fill($input);
        if (!$roles->update()) {
            throw new \Exception();
        }
        return $roles;
    }

    public function createNewGroup($input)
    {
        $groups = $this->store($input);
        if (!empty($input["access"])) {
            $total = count($input["access"]);
            $totalAccess = array();
            if ($total !== 0) {
                for ($i = 0; $i < $total; $i++) {
                    $totalAccess[] = [
                        "groupid" => $groups,
                        "accessid" => $input["access"][$i]
                    ];
                }
                AdministratorgroupaccessModel::insert($totalAccess);
            }
        }
        if (!empty($input["lokasiitem"])) {
            $total = count($input["lokasiitem"]);
            $totalAccess = array();
            if ($total !== 0) {
                for ($i = 0; $i < $total; $i++) {
                    $totalAccess[] = [
                        "roleId" => $groups,
                        "lokasiId" => $input["lokasiitem"][$i]
                    ];
                }
                RolelokasiitemModel::insert($totalAccess);
            }
        }

        if (!empty($input["category"])) {
            $total = count($input["category"]);
            $totalAccess = array();
            if ($total !== 0) {
                for ($i = 0; $i < $total; $i++) {
                    $totalAccess[] = [
                        "roleId" => $groups,
                        "categoryId" => $input["category"][$i]
                    ];
                }
                RolecategoryModel::insert($totalAccess);
            }
        }
        return $groups;

    }

    public function updateGroup($id, $input)
    {
        $groups = $this->update($id, $input);

        (new AdministratorgroupaccessModel())->deleteData()->where("administratorgroupaccess.groupid", "=", $id)->delete();
        if (!empty($input["access"])) {            
            $total = count($input["access"]);
            $totalAccess = array();
            if ($total !== 0) {
                for ($i = 0; $i < $total; $i++) {
                    $totalAccess[] = [
                        "groupid" => $groups->id,
                        "accessid" => $input["access"][$i]
                    ];
                }
                AdministratorgroupaccessModel::insert($totalAccess);
            }
        }

        (new RolelokasiitemModel())->deleteData()->where("rolelokasiitem.roleId", "=", $id)->delete();
        if (!empty($input["lokasiitem"])) {            
            $total = count($input["lokasiitem"]);
            $totalAccess = array();
            if ($total !== 0) {
                for ($i = 0; $i < $total; $i++) {
                    $totalAccess[] = [
                        "roleId" => $groups->id,
                        "lokasiId" => $input["lokasiitem"][$i]
                    ];
                }
                RolelokasiitemModel::insert($totalAccess);
            }
        }

        (new RolecategoryModel())->deleteData()->where("rolecategory.roleId", "=", $id)->delete();
        if (!empty($input["category"])) {            
            $total = count($input["category"]);
            $totalAccess = array();
            if ($total !== 0) {
                for ($i = 0; $i < $total; $i++) {
                    $totalAccess[] = [
                        "roleId" => $groups->id,
                        "categoryId" => $input["category"][$i]
                    ];
                }
                RolecategoryModel::insert($totalAccess);
            }
        }
        return $groups;

    }

    /**
     *  this function will be confirting paging property into file excel
     *  the main library is base on excel spreadsheet library
     * @param array $input
     * @return array|static[]
     */
    public function exportToExcel($input = array())
    {
        return $this->model->getQuery()->get();
    }

    public function getList($request) {
		return $this->model->getQuery()->get();
	}

}